



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C#图解教程 第十五章 接口</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C#图解教程 第十五章 接口</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 04:37:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div><a href="#wiz_toc_0" rel="external nofollow noreferrer">接口</a></div>
<div><a href="#wiz_toc_1" rel="external nofollow noreferrer">什么是接口</a></div>
<div><a href="#wiz_toc_2" rel="external nofollow noreferrer">使用IComparable接口的示例</a></div>
<div><a href="#wiz_toc_3" rel="external nofollow noreferrer">声明接口</a><br /><a href="#wiz_toc_4" rel="external nofollow noreferrer">实现接口</a></div>
<div><a href="#wiz_toc_5" rel="external nofollow noreferrer">简单接口示例</a></div>
<div><a href="#wiz_toc_6" rel="external nofollow noreferrer">接口是引用类型</a><br /><a href="#wiz_toc_7" rel="external nofollow noreferrer">接口和as运算符</a><br /><a href="#wiz_toc_8" rel="external nofollow noreferrer">实现多个接口</a><br /><a href="#wiz_toc_9" rel="external nofollow noreferrer">实现具有重复成员的接口</a><br /><a href="#wiz_toc_10" rel="external nofollow noreferrer">多个接口的引用</a><br /><a href="#wiz_toc_11" rel="external nofollow noreferrer">派生成员作为实现</a><br /><a href="#wiz_toc_12" rel="external nofollow noreferrer">显式接口成员实现</a></div>
<div><a href="#wiz_toc_13" rel="external nofollow noreferrer">访问显式接口成员实现</a></div>
<div><a href="#wiz_toc_14" rel="external nofollow noreferrer">接口可以继承接口</a><br /><a href="#wiz_toc_15" rel="external nofollow noreferrer">不同类实现一个接口的示例</a></div>
<h2>接口</h2>
<h3>什么是接口</h3>
<hr />
<p>接口是指定一组函数成员而不实现它们的引用类型。所以只能类和结构来实现接口。 <br />
这种描述比较抽象，直接来看个示例。 <br />
下例中，Main方法创建并初始化了一个CA类的对象，并将该对象传递给PrintInfo方法。</p>
<div>
<pre class="prettyprint linenums">class CA<br />
{<br />
    public string Name;<br />
    public int Age;<br />
}<br />
class CB<br />
{<br />
    public string First;<br />
    public string Last;<br />
    public double PersonsAge;<br />
}<br />
class Program<br />
{<br />
    static void PrintInfo(CA item)<br />
    {<br />
        Console.WriteLine("Name: {0},Age {1}",item.Name,item.Age);<br />
    }<br />
    static void Main()<br />
    {<br />
        CA a=new CA(){Name="John Doe",Age=};<br />
        PrintInfo(a);<br />
    }<br />
}</pre>
</div>
<p>只要传入的是CA类型的对象，PrintInfo就能正常工作。但如果传入的是CB，就不行了。 <br />
现在的代码不能满足上面的需求，原因有很多。</p>
<ul><li>PrintInfo的形参指明了实参必须为CA类型的对象</li>
<li>CB的结构与CA不同，字段的名称和类型与CA不一样</li></ul>
<p>接口解决了这一问题。</p>
<ul><li>声明一个IInfo接口，包含两个方法&ndash;GetName和GetAge，每个方法都返回string</li>
<li>类CA和CB各自实现了IInfo接口，并实现了两个方法</li>
<li>Main创建了CA和CB的实例，并传入PrintInfo</li>
<li>由于类实例实现了接口，PrintInfo可以调用那两个方法，每个类实例执行各自的方法，就好像是执行自己类声明中的方法</li></ul>
<div>
<pre class="prettyprint linenums">interface IInfo       //声明接口<br />
{<br />
    string GetName();<br />
    string GetAge();<br />
}<br />
class CA:IInfo         //声明了实现接口的CA类<br />
{<br />
    public string Name;<br />
    public int Age;<br />
    public string GetName(){return Name;}<br />
    public string GetAge(){return Age.ToString();}<br />
}<br />
class CB:IInfo         //声明了实现接口的CB类<br />
{<br />
    public string First;<br />
    public string Last;<br />
    public double PersonsAge;<br />
    public string GetName(){return First+""+Last;}<br />
    public string GetAge(){return PersonsAge.ToString();}<br />
}<br />
class Program<br />
{<br />
    static void PrintInfo(IInfo item)<br />
    {<br />
        Console.WriteLine("Name: {0},Age {1}",item.GetName(),item.GetAge());<br />
    }<br />
    static void Main()<br />
    {<br />
        var a=new CA(){Name="John Doe",Age=};<br />
        var b=new CB(){First="Jane",Last="Doe",PersonsAge=};<br />
        PrintInfo(a);<br />
        PrintInfo(b);<br />
    }<br />
}</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/759721/201701/759721-20170124091323191-1794524310.jpg" /></p>
<p><img referrerpolicy="no-referrer"/></p>
<h5>使用IComparable接口的示例</h5>
<ul><li>第一行代码创建了包含5个无序整数的数组</li>
<li>第二行代码使用了Array类的静态Sort方法来排序元素</li>
<li>用foreach循环输出它们，显式以升序排序的数字</li></ul>
<div>
<pre class="prettyprint linenums">var myInt=new[]{,,,,};<br />
Array.Sort(myInt);<br />
foreach(var i in myInt)<br />
{<br />
    Console.WriteLine("{0}",i);<br />
}</pre>
</div>
<p>Sort方法在int数组上工作良好，但如果我们尝试在自己的类上使用会发生什么呢？</p>
<div>
<pre class="prettyprint linenums">class MyClass<br />
{<br />
    public int TheValue;<br />
}<br />
...<br />
MyClass[] mc=new MyClass[];<br />
...<br />
Array.Sort(mc);</pre>
</div>
<p>运行上面的代码，将会得到一个异常。Sort并不能对MyClass对象数组排序，因为它不知道如何比较自定义的对象。Array类的Sort方法其实依赖于一个叫做IComparable的接口，它声明在BCL中，包含唯一的方法CompareTo。</p>
<div>
<pre class="prettyprint linenums">public interface IComparable<br />
{<br />
    int CompareTo(object obj);<br />
}</pre>
</div>
<p>尽管接口声明中没有为CompareTo方法提供实现，但IComparable接口的.NET文档中描述了该方法应该做的事情，可以在创建实现该接口的类或结构时参考。 <br />
文档中写到，在调用CompareTo方法时，它应该返回以下几个值：</p>
<ul><li>负数值 当前对象小于参数对象</li>
<li>整数值 当前对象大于参数对象</li>
<li>零 两个对象相等</li></ul>
<p>我们可以通过让类实现IComparable来使Sort方法可以用于MyClass对象。要实现一个接口，类或结构必须做两件事情：</p>
<ul><li>必须在基类列表后面列出接口名称</li>
<li>必须实现接口的每个成员</li></ul>
<p>例：MyClass中实现了IComparable接口</p>
<div>
<pre class="prettyprint linenums">class MyClass:IComparable<br />
{<br />
    public int TheValue;<br />
    public int CompareTo(object obj)<br />
    {<br />
        var mc=(MyClass)obj;<br />
        if(this.TheValue&lt;mc.TheValue)return -;<br />
        if(this.TheValue&gt;mc.TheValue)return  ;<br />
        return ;<br />
    }<br />
}</pre>
</div>
<p>例：完整示例代码</p>
<div>
<pre class="prettyprint linenums">class MyClass:IComparable<br />
{<br />
    public int TheValue;<br />
    public int CompareTo(object obj)<br />
    {<br />
        var mc=(MyClass)obj;<br />
        if(this.TheValue&lt;mc.TheValue)return -;<br />
        if(this.TheValue&gt;mc.TheValue)return  ;<br />
        return ;<br />
    }<br />
}<br />
class Program<br />
{<br />
    static void PrintInfo(string s,MyClass[] mc)<br />
    {<br />
        Console.WriteLine(s);<br />
        foreach(var m in mc)<br />
        {<br />
            Console.WriteLine("{0}",m.TheValue);<br />
        }<br />
        Console.WriteLine("");<br />
    }<br />
    static void Main()<br />
    {<br />
        var myInt=new[] {,,,,};<br />
        MyClass[] mcArr=new MyClass[];<br />
        for(int i=;i&lt;;i++)<br />
        {<br />
            mcArr[i]=new MyClass();<br />
            mcArr[i].TheValue=myInt[i];<br />
        }<br />
        PrintOut("Initial Order: ",mcArr);<br />
        Array.Sort(mcArr);<br />
        PrintOut("Sorted Order: ",mcArr);<br />
    }<br />
}</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/759721/201701/759721-20170124091444237-2030367311.jpg" /></p>
<p><img referrerpolicy="no-referrer"/></p>
<h3>声明接口</h3>
<hr />
<p>上一节使用的是BCL中已有的接口。现在我们来看看如何声明接口。 <br />
关于声明接口，需要知道的重要事项如下：</p>
<ul><li>接口声明不能包含以下成员</p>
<ul><li>数据成员</li>
<li>静态成员</li></ul></li>
<li>接口声明只能包含如下类型的非静态成员函数的声明
<ul><li>方法</li>
<li>属性</li>
<li>事件</li>
<li>索引器</li></ul></li>
<li>这些函数成员的声明不能包含任何实现代码，只能用分号</li>
<li>按照惯例，接口名称以大写字母I(Interface)开始</li>
<li>与类和结构一样，接口声明也可以分布</li></ul>
<p>例：两个方法成员接口的声明</p>
<div>
<pre class="prettyprint linenums">  关键字     接口名称<br />
    &darr;          &darr;<br />
interface IMyInterface1<br />
{<br />
    int DoStuff(int nVar1,long lVar2);  //分号替代了主体<br />
    double DoOtherStuff(string s,long x);<br />
}</pre>
</div>
<p>接口的访问性和接口成员的访问性之间有一些重要区别</p>
<ul><li>接口声明可以有任何的访问修饰符public、protected、internal或private</li>
<li>然而，接口的成员是隐式public的，不允许有任何访问修饰符，包括public</li></ul>
<div>
<pre class="prettyprint linenums">接口允许访问修饰符<br />
   &darr;<br />
public interface IMyInterface2<br />
{<br />
    private int Method1(int nVar1); //错误<br />
       &uarr;<br />
接口成员不允许访问修饰符<br />
}</pre>
</div>
<h3>实现接口</h3>
<hr />
<p>只有类和结构才能实现接口。</p>
<ul><li>在基类列表中包括接口名称</li>
<li>实现每个接口成员</li></ul>
<p>例：MyClass实现IMyInterface1接口</p>
<div>
<pre class="prettyprint linenums">class MyClass:IMyInterface1<br />
{<br />
    int DoStuff(int nVar1,long lVar2)<br />
    {...}    //实现代码<br />
    double DoOtherStuff(string s,long x)<br />
    {...}    //实现代码<br />
}</pre>
</div>
<p>关于实现接口，需要了解以下重要事项：</p>
<ul><li>如果类实现了接口，它必须实现接口的所有成员</li>
<li>如果类从基类继承并实现了接口，基类列表中的基类名称必须放在所有接口之前。</li></ul>
<div>
<pre class="prettyprint linenums">           基类必须放在最前面       接口名<br />
                  &darr;                 &darr;<br />
class Derived:MyBaseClass,IIfc1,IEnumerable,IComparable</pre>
</div>
<h5>简单接口示例</h5>
<div>
<pre class="prettyprint linenums">interface IIfc1<br />
{<br />
    void PrintOut(string s);<br />
}<br />
class MyClass:IIfc1<br />
{<br />
    public void PrintOut(string s)<br />
    {<br />
        Console.WriteLine("Calling through: {0}",s);<br />
    }<br />
}<br />
class Program<br />
{<br />
    static void Main()<br />
    {<br />
        var mc=new MyClass();<br />
        mc.PrintOut("object");<br />
    }<br />
}</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/759721/201701/759721-20170124091646534-323941243.jpg" /></p>
<p><img referrerpolicy="no-referrer"/></p>
<h3>接口是引用类型</h3>
<hr />
<p>接口不仅是类或结构要实现的成员列表。它是一个引用类型。 <br />
我们不能直接通过类对象的成员访问接口。然而，我们可以通过把类对象引用强制转换为接口类型来获取指向接口的引用。一旦有了接口引用，我们就可以使用点号来调用接口方法。</p>
<p>例：从类对象引用获取接口引用</p>
<div>
<pre class="prettyprint linenums">IIfc1 ifc=(IIfc1)mc;         //转换为接口，获取接口引用<br />
ifc.PrintOut("interface");   //使用接口的引用调用方法</pre>
</div>
<p>例：类和接口的引用</p>
<div>
<pre class="prettyprint linenums">interface IIfc1<br />
{<br />
    void PrintOut(string s);<br />
}<br />
class MyClass:IIfc1<br />
{<br />
    public void PrintOut(string s)<br />
    {<br />
        Console.WriteLine("Calling through: {0}",s);<br />
    }<br />
}<br />
class Program<br />
{<br />
    static void Main()<br />
    {<br />
        var mc=new MyClass();<br />
        mc.PrintOut("object");    //调用类对象的实现方法<br />
        IIfc1 ifc=(IIfc1)mc;<br />
        ifc.PrintOut("interface"); //调用引用方法<br />
    }<br />
}</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/759721/201701/759721-20170124091717472-1660178429.jpg" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/759721/201701/759721-20170124091727472-734557872.jpg" /></p>
<p><img referrerpolicy="no-referrer"/></p>
<p><img referrerpolicy="no-referrer"/></p>
<h3>接口和as运算符</h3>
<hr />
<p>上一节，我们已经知道可以使用强制转换运算符来获取对象接口引用，另一个更好的方式是使用as运算符。 <br />
如果我们尝试将类对象引用强制转换为类<strong>未实现</strong>的接口的引用，强制转换操作会抛出异常。我们可以通过as运算符来避免该问题。</p>
<ul><li>如果类实现了接口，表达式返回指向接口的引用</li>
<li>如果类没有实现接口，表达式返回null</li></ul>
<div>
<pre class="prettyprint linenums">ILiveBirth b=a as ILiveBirth;<br />
if(b!=null)<br />
{<br />
    Console.WriteLine("Baby is called: {0}",b.BabyCalled());<br />
}</pre>
</div>
<h3>实现多个接口</h3>
<hr />
<ul><li>类或结构可以实现多个接口</li>
<li>所有实现的接口必须列在基类列表中并以逗号分隔（如果有基类名称，则在其后）</li></ul>
<div>
<pre class="prettyprint linenums">interface IDataRetrieve{int GetData();}<br />
interface IDataStore{void SetData(int x);}<br />
class MyData:IDataRetrieve,IDataStore<br />
{<br />
    int Mem1;<br />
    public int GetData(){return Mem1;}<br />
    public void SetData(int x){Mem1=x;}<br />
}<br />
class Program<br />
{<br />
    static void Main()<br />
    {<br />
        var data=new MyData();<br />
        data.SetData();<br />
        Console.WriteLine("Value = {0}",data.GetData());<br />
    }<br />
}</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/759721/201701/759721-20170124091807831-507397160.jpg" /></p>
<p><img referrerpolicy="no-referrer"/></p>
<h3>实现具有重复成员的接口</h3>
<hr />
<p>由于接口可以多实现，有可能多个接口有相同的签名和返回类型。编译器如何处理这种情况呢？ <br />
例：IIfc1和IIfc2具有相同签名</p>
<div>
<pre class="prettyprint linenums">interface IIfc1<br />
{<br />
    void PrintOut(string s);<br />
}<br />
interface IIfc2<br />
{<br />
    void PrintOut(string t);<br />
}</pre>
</div>
<p>答案是：如果一个类实现了多接口，并且其中有些接口有相同签名和返回类型，那么类可以实现单个成员来满足所有包含重复成员的接口。 <br />
例：MyClass 类实现了IIfc1和IIfc2.PrintOut满足了两个接口的需求。</p>
<div>
<pre class="prettyprint linenums">class MyClass：IIfc1,IIfc2<br />
{<br />
    public void PrintOut(string s)//两个接口单一实现<br />
    {<br />
        Console.WriteLine("Calling through: {0}",s);<br />
    }<br />
}<br />
class Program<br />
{<br />
    static void Main()<br />
    {<br />
        var mc=new MyClass();<br />
        mc.PrintOut("object");<br />
    }<br />
}</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/759721/201701/759721-20170124091919941-1468596060.jpg" /></p>
<p><img referrerpolicy="no-referrer"/></p>
<h3>多个接口的引用</h3>
<hr />
<p>如果类实现了多接口，我们可以获取每个接口的独立引用。</p>
<p>例：下面类实现了两个具有当PrintOut方法的接口，Main中以3种方式调用了PrintOut。</p>
<ul><li>通过类对象</li>
<li>通过指向IIfc1接口的引用</li>
<li>通过指向IIfc2接口的引用</li></ul>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/759721/201701/759721-20170124091942175-1307802079.jpg" /></p>
<p><img referrerpolicy="no-referrer"/></p>
<div>
<pre class="prettyprint linenums">interface IIfc1<br />
{<br />
    void PrintOut(string s);<br />
}<br />
interface IIfc2<br />
{<br />
    void PrintOut(string t);<br />
}<br />
class MyClass：IIfc1,IIfc2<br />
{<br />
    public void PrintOut(string s)<br />
    {<br />
        Console.WriteLine("Calling through: {0}",s);<br />
    }<br />
}<br />
class Program<br />
{<br />
    static void Main()<br />
    {<br />
        var mc=new MyClass();<br />
        IIfc1 ifc1=(IIfc1)mc;<br />
        IIfc2 ifc2=(IIfc2)mc;<br />
        mc.PrintOut("object");<br />
        ifc1.PrintOut("interface 1");<br />
        ifc2.PrintOut("interface 2");<br />
    }<br />
}</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/759721/201701/759721-20170124092008722-977112807.jpg" /></p>
<p><img referrerpolicy="no-referrer"/></p>
<h3>派生成员作为实现</h3>
<hr />
<p>实现接口的类可以从它的基类继承实现的代码。 <br />
例：演示 类从基类代码继承了实现</p>
<ul><li>IIfc1是一个具有PrintOut方法成员的接口</li>
<li>MyBaseClass包含一个PrintOut方法，它和IIfc1匹配</li>
<li>Derived类有空的声明主体，但它派生自MyBaseClass，并在基类列表中包含了IIfc1</li>
<li>即使Derived的声明主体为空，基类中的代码还是能满足实现接口方法的需求</li></ul>
<div>
<pre class="prettyprint linenums">interface IIfc1<br />
{<br />
    void PrintOut(string s);<br />
}<br />
class MyBaseClass<br />
{<br />
    public void PrintOut(string s)<br />
    {<br />
        Console.WriteLine("Calling through: {0}",s);<br />
    }<br />
}<br />
class Derived:MyBaseClass,IIfc1<br />
{<br />
}<br />
class Program<br />
{<br />
    static void Main()<br />
    {<br />
        var d=new Derived();<br />
        d.PrintOut("object");<br />
    }<br />
}</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/759721/201701/759721-20170124092027050-1947042635.jpg" /></p>
<p><img referrerpolicy="no-referrer"/></p>
<h3>显式接口成员实现</h3>
<hr />
<p>上面，我们已经看到了单个类可以实现多个接口需要的所有成员。 <br />
但是，如果我们希望为每个接口分离实现该怎么做呢？这种情况下，我们可以创建<em>显式接口成员实现</em>。</p>
<ul><li>与所有接口实现相似，位于实现了接口的类或结构中</li>
<li>它使用<em>限定接口名称</em>来声明，由接口名称和成员名称以及它们中间的点分隔符号构成</li></ul>
<div>
<pre class="prettyprint linenums">class MyClass:IIfc1,IIfc2<br />
{<br />
    void IIfc1.PrintOut(string s)<br />
    {...}<br />
    void IIfc2.PrintOut(string s)<br />
    {...}<br />
}</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/759721/201701/759721-20170124092041425-2052646487.jpg" /></p>
<p><img referrerpolicy="no-referrer"/></p>
<p>例：MyClass为两个解耦的成员声明了显式接口成员实现。</p>
<div>
<pre class="prettyprint linenums">interface IIfc1<br />
{<br />
    void PrintOut(string s);<br />
}<br />
interface IIfc2<br />
{<br />
    void PrintOut(string t);<br />
}<br />
class MyClass：IIfc1,IIfc2<br />
{<br />
    void IIfc1.PrintOut(string s)<br />
    {<br />
        Console.WriteLine("IIfc1: {0}",s);<br />
    }<br />
    void IIfc2.PrintOut(string s)<br />
    {<br />
        Console.WriteLine("IIfc2: {0}",s);<br />
    }<br />
}<br />
class Program<br />
{<br />
    static void Main()<br />
    {<br />
        var mc=new MyClass();<br />
        IIfc1 ifc1=(IIfc1)mc;<br />
        ifc1.PrintOut("interface 1");<br />
        IIfc2 ifc2=(IIfc2)mc;<br />
        ifc2.PrintOut("interface 2");<br />
    }<br />
}</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/759721/201701/759721-20170124092101472-1081521007.jpg" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/759721/201701/759721-20170124092111159-1978909440.jpg" /></p>
<p><img referrerpolicy="no-referrer"/> <br />
<img referrerpolicy="no-referrer"/> <br />
如果有显式接口成员实现，类级别的实现是允许的，但不是必需的。显式实现满足了类或结构必须实现的方法。因此，我们可以有如下3种实现场景。</p>
<ul><li>类级别实现</li>
<li>显式接口成员实现</li>
<li>类级别和显式接口成员实现</li></ul>
<h5>访问显式接口成员实现</h5>
<p>显式接口成员实现只可以通过指向接口的引用来访问。即其他的类成员都不可以直接访问它们。 <br />
例：如下MyClass显式实现了IIfc1接口。注意，即使是MyClass的另一成员Method1，也不可以直接访问显式实现。</p>
<ul><li>Method1的前两行编译错误，因为方法在尝试直接访问实现</li>
<li>只有Method1的最后一行代码才可以编译，因此它强制转换当前对象的引用（this）为接口类型的引用，并使用这个指向接口的引用来调用显式接口实现</li></ul>
<div>
<pre class="prettyprint linenums">class MyClass:IIfc1<br />
{<br />
    void IIfc1.PrintOut(string s)<br />
    {<br />
        Console.WriteLine("IIfc1");<br />
    }<br />
    public void Method1()<br />
    {<br />
        PrintOut("...");         //编译错误<br />
        this.PrintOut("...");    //编译错误<br />
        ((IIfc1)this).PrintOut("...");<br />
            &uarr;<br />
       转换为接口引用<br />
    }<br />
}</pre>
</div>
<p>这个限制对继承产生了重要影响。由于其他类成员不能直接访问显式接口成员实现，衍生类的成员也不能直接访问它们。它们必须总是通过接口的引用来访问。</p>
<h3>接口可以继承接口</h3>
<hr />
<p>之前我们已经知道接口实现可以从基类继承，而接口本身也可以从一个或多个接口继承。</p>
<ul><li>要指定某个接口继承其他的接口，应在接口声明中把某接口以逗号分隔的列表形式放在接口名称的冒号之后</li>
<li>与类不同，它在基类列表中只能有一个类名，接口可以在基接口列表中有任意多个接口
<ul><li>列表中的接口本身可以继承其他接口</li>
<li>结果接口包含它声明的所有接口和所有基接口的成员</li></ul></li></ul>
<div>
<pre class="prettyprint linenums">interface IDataIO:IDataRetrieve,IDataStore<br />
{<br />
   ...<br />
}</pre>
</div>
<p>例：IDataIO接口继承了两个接口</p>
<div>
<pre class="prettyprint linenums">interface IDataRetrieve<br />
{<br />
   int GetData();<br />
}<br />
interface IDataStore<br />
{<br />
    void SetData(int x);<br />
}<br />
interface IDaTaIO：IDataRetrieve,IDataStore<br />
{<br />
}<br />
class MyData:IDataIO<br />
{<br />
    int nPrivateData;<br />
    public int GetData()<br />
    {<br />
        return nPrivateData;<br />
    }<br />
    public void SetData(int x)<br />
    {<br />
        nPrivateData=x;<br />
    }<br />
}<br />
class Program<br />
{<br />
    static void Main()<br />
    {<br />
        var data=new MyData();<br />
        data.SetData();<br />
        Console.WriteLine("{0}",data.GetData());<br />
    }<br />
}</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/759721/201701/759721-20170124092152862-950173193.jpg" /></p>
<p><img referrerpolicy="no-referrer"/></p>
<h3>不同类实现一个接口的示例</h3>
<hr />
<div>
<pre class="prettyprint linenums">interface ILiveBirth              //声明接口<br />
{<br />
    string BabyCalled();<br />
}<br />
class Animal{}                    //基类Animal<br />
class Cat:Animal,ILiveBirth       //声明Cat类<br />
{<br />
    string ILiveBirth.BabyCalled()<br />
    {<br />
        return "kitten";<br />
    }<br />
}<br />
class Dog:Animal,ILiveBirth       //声明DOg类<br />
{<br />
    string ILiveBirth.BabyCalled()<br />
    {<br />
        return "puppy";<br />
    }<br />
}<br />
class Bird:Animal                 //声明Bird类<br />
{<br />
}<br />
class Program<br />
{<br />
    static void Main()<br />
    {<br />
        Animal[] animalArray=new Animal[];<br />
        animalArray[]=new Cat();<br />
        animalArray[]=new Bird();<br />
        animalArray[]=new Dog();<br />
        foreach(Animal a in animalArray)<br />
        {<br />
            ILiveBirth b= a as ILiveBirth;//如果实现ILiveBirth<br />
            if(b!=null)<br />
            {<br />
            Console.WriteLine("Baby is called: {0}",b.BabyCalled());<br />
            }<br />
        }<br />
    }<br />
}</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/759721/201701/759721-20170124092216206-114811588.jpg" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/759721/201701/759721-20170124092222769-2117748621.jpg" /></p>
<p><img referrerpolicy="no-referrer"/></p>
<p><img referrerpolicy="no-referrer"/></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49g35x0q.html">GET和POST可传递的值到底有多大？</a>
		</li>
						<li><a href="https://www.batexi.com/a/390dy3o8.html">ucenter用户登录过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv5wm1q.html">Babelfish                                                       分类：            哈希             2015-08-04 09&colon;25    2人阅读    评论&lpar;0&rpar;    收藏</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd1ojgq.html">jquery zclip 复制黏贴功能不能实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xjv168.html">linux 在xenserver上安装如何显示图形界面</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn4y3e8.html">http协议与内容压缩</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1znl169.html">如何在Html的div&plus;css中去除&amp;lt&semi;li&amp;gt&semi;标签前面小黑点&comma;和ul、LI部分属性方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w1myoq.html">SRM 601&lpar;1-250pt&comma;500pt&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkwopd8.html">ubuntu下vpn无反应的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1v2z1q.html">Mac os 进行Android开发笔记（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgrw278.html">Web 前台优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwxdwz8.html">windows系统yolov3的安装教程（图文）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv075y8.html">oracle左连接连表查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/960ydyv9.html">oracle函数返回结果集</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rk5rm9.html">Django用openLDAP做认证</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5pp6rq.html">手把手教你整合最优雅SSM框架：SpringMVC &plus; Spring &plus; MyBatis</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyjxgxq.html">getopt&lowbar;long&lowbar;only</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv2l6z8.html">Batch Normalization 引出的一系列问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv1x5z8.html">搭建Java后台</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7op77x8.html">在自己网站中引入CU3ER&sol;Flash 3D幻灯片效果和照片画框</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/950y5008.html">react native 常用组件汇总</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdypdd9.html">基于Java SE集合的充值管理系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjeljz8.html">Java经典编程题50道之四十四</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kplod79.html">Spring框架系列之AOP思想</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1lvndq.html">iOS 添加WKWebView导致控制器无法释放的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mevj00q.html">Spring-Security自定义登录页&amp;amp&semi;inMemoryAuthentication验证</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kplm439.html">PHP不使用任何内置函数实现字符串翻转</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jn0538.html">soj1091 指环王  bfs&plus;hash&plus;剪枝</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pkypv8.html">OSQA的配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey7w7m9.html">普通权限拿webshell</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
